/* 
(C) OOMusou 2011 http://oomusou.cnblogs.com

Filename    : function_pointer.v
Compiler    : Visual Studio 2008
Description : function pointer by C
Release     : 02/12/2011 1.0
*/

#include <stdio.h>
#include <string.h>

typedef void (*fptr)(char *s); // function pointer
void write_to_console(char *s);
void write_to_file(char *s);
void display_message(fptr m, char *s);

int main() {
  int i;
  char s[] = "Hello World";
  fptr m;
  
  printf("1:write to console, 2:write to text\n");
  i = getchar();
  
  if (i == 49) // ASCII : 1
    m = write_to_console;
  else
    m = write_to_file;
    
  display_message(m, s); // use function pointer to pass a function    
}

void write_to_console(char *s) {
  printf("%s\n", s);
}

void write_to_file(char *s) {
  FILE *fp;
  fp = fopen("test.txt", "w");
  fwrite(s, strlen(s), 1, fp);
  fclose(fp);
}

void display_message(fptr m, char *s) {
  (*m)(s); // use function pointer to call function
}


